## diodon 1.0.1

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Oliver Sauder, 2010

import subprocess, os, traceback, waflib
import Options, Logs
from waflib.Tools import waf_unit_test

NAME = 'Diodon'
VERSION = '1.0.1'
APPNAME = 'diodon'
WEBSITE = 'https://launchpad.net/diodon'
COPYRIGHT = 'Copyright \xc2\xa9 2010 Diodon Team'
BUSNAME = 'net.launchpad.Diodon'
BUSOBJECTPATH = '/net/launchpad/diodon'

VERSION_MAJOR_MINOR = '.'.join (VERSION.split ('.')[0:2])
VERSION_MAJOR = '.'.join (VERSION.split ('.')[0:1])
top = '.'
out = '_build_'

def options(opt):
    opt.tool_options('compiler_c')
    opt.tool_options('waf_unit_test')
    opt.tool_options('vala')
    opt.tool_options('gnu_dirs')
    opt.tool_options('intltool')
    opt.tool_options('glib2')
    opt.add_option('--update-po',                action='store_true', default=False, dest='update_po', help='Update localization files')
    opt.add_option('--debug',                    action='store_true', default=False, dest='debug',     help='Debug mode')
    opt.add_option('--disable-indicator-plugin', action='store_true', default=False, dest='disable_indicator', help='Disable build of indicator plugin')
    opt.add_option('--enable-unitylens-plugin',  action='store_true', default=False, dest='enable_unitylens', help='Enable build of unity lens plugin')
    opt.add_option('--enable-zeitgeist-plugin',  action='store_true', default=False, dest='enable_zeitgeist', help='Enable build of zeitgeist plugin')
    opt.add_option('--build-doc',                action='store_true', default=False, dest='doc', help='Build the api documentation')
    opt.add_option('--skiptests',                action='store_true', default=False, dest='skiptests', help='Skip unit tests')

def configure(conf):
    conf.load('compiler_c intltool gnu_dirs glib2 waf_unit_test')
    if Options.options.doc:
    	conf.load('valadoc')
    
    conf.load('vala', funs='')
    conf.check_vala(min_version=(0,16,0))
    
    conf.check_cfg(package='gdk-3.0',           uselib_store='GDK',          atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gdk-x11-3.0',       uselib_store='GDKX',         atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gee-1.0',           uselib_store='GEE',          atleast_version='0.5.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='libpeas-1.0',       uselib_store='PEAS',         atleast_version='1.1.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='libpeas-gtk-1.0',   uselib_store='PEASGTK',      atleast_version='1.1.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gio-2.0',           uselib_store='GIO',          atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gio-unix-2.0',      uselib_store='GIOUNIX',      atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='glib-2.0',          uselib_store='GLIB',         atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gtk+-3.0',          uselib_store='GTK',          atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='libxml-2.0',        uselib_store='XML',          atleast_version='2.7.6',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='unique-3.0',        uselib_store='UNIQUE',       atleast_version='3.0.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='x11',               uselib_store='X11',          atleast_version='1.3.2',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='xtst',              uselib_store='XTST',         atleast_version='1.2.0',  mandatory=1, args='--cflags --libs')
    
    # FIXME: waf throws up when assigning an empty string
    # we need a better way of configuring plugins which are enabled
    # by default anyway
    ACTIVE_PLUGINS = ' '
    # check if indicator plugin should be built
    conf.env['INDICATOR'] = not(Options.options.disable_indicator)
    if not(Options.options.disable_indicator):
        conf.check_cfg(package='appindicator3-0.1', uselib_store='APPINDICATOR', atleast_version='0.3.0',  mandatory=1, args='--cflags --libs')
        ACTIVE_PLUGINS = "'indicator'"
        
    # check if unity lens plugin should be built
    conf.env['UNITYLENS'] = Options.options.enable_unitylens
    if Options.options.enable_unitylens:
        conf.check_cfg(package='unity',   uselib_store='UNITY', atleast_version='5.8.0',  mandatory=1, args='--cflags --libs')
        conf.check_cfg(package='dee-1.0', uselib_store='DEE',   atleast_version='0.5.18', mandatory=1, args='--cflags --libs')
      
    conf.env['ZEITGEIST'] = Options.options.enable_zeitgeist
    if Options.options.enable_zeitgeist:
        conf.check_cfg(package='zeitgeist-1.0', uselib_store='ZEITGEIST', atleast_version='0.3.12', mandatory=1, args='--cflags --libs')    

    # FIXME: conf.env and conf.define should not both be needed?
    conf.define('PACKAGE_NAME', APPNAME)
    conf.env['PACKAGE_NAME'] = APPNAME
    conf.define('ACTIVE_PLUGINS', ACTIVE_PLUGINS)
    conf.env['ACTIVE_PLUGINS'] = ACTIVE_PLUGINS
    conf.define('GETTEXT_PACKAGE', APPNAME)
    conf.env['GETTEXT_PACKAGE'] = APPNAME
    conf.define('VERSION', VERSION)
    conf.env['VERSION'] = VERSION
    conf.define('COPYRIGHT', COPYRIGHT)
    conf.define('WEBSITE', WEBSITE)
    conf.define('APPNAME', NAME)
    conf.define('BUSNAME', BUSNAME)
    conf.env['BUSNAME'] = BUSNAME
    conf.define('BUSOBJECTPATH', BUSOBJECTPATH)
    conf.env['BUSOBJECTPATH'] = BUSOBJECTPATH
    conf.define('SHAREDIR', os.path.join(conf.env['DATADIR'], APPNAME))
    conf.define('LIBDIR', os.path.join(conf.env['LIBDIR'], APPNAME))
    conf.define('PLUGINS_DIR', os.path.join(conf.env['LIBDIR'], APPNAME, 'plugins'))
    conf.env['PLUGINS_DIR'] = os.path.join(conf.env['LIBDIR'], APPNAME, 'plugins')
    conf.define('PLUGINS_DATA_DIR', os.path.join(conf.env['DATADIR'], APPNAME, 'plugins'))
      
    # set 'default' variant
    conf.define ('DEBUG', 0)
    conf.env['CFLAGS']=['-O2']
    conf.env['VALAFLAGS'] = ['--disable-assert']
    
    # set some debug relevant config values
    if Options.options.debug:
        conf.define ('DEBUG', 1)
        conf.env['CFLAGS'] = ['-O0', '-g3']
        conf.env['VALAFLAGS'] = ['-g', '-v', '--enable-checking']

    conf.write_config_header ('config.h', remove=False)

def build(ctx):
    ctx.add_subdirs('po data libdiodon plugins diodon')
    
    if not Options.options.skiptests:
        ctx.add_subdirs('tests')
        
    if ctx.env['VALADOC']:
    	ctx.add_subdirs('doc')
    ctx.add_post_fun(post)
    
    # to execute all tests:
	# $ waf --alltests
	# to set this behaviour permanenly:    
    ctx.options.all_tests = True

def post(ctx):
    waf_unit_test.summary(ctx)
    
    # Tests have to pass
    lst = getattr(ctx, 'utest_results', [])
    if lst:
        tfail = len([x for x in lst if x[1]])
        if tfail:
            ctx.fatal("Some test failed.")
	
    if ctx.cmd == 'install':
        ctx.exec_command('/sbin/ldconfig')

def dist(ctx):
    # set the compression type to gzip (default is bz2)
    ctx.algo = "tar.gz"
  
def shutdown(self):
    if Options.options.update_po:
        os.chdir('./po')
        try:
            try:
                size_old = os.stat (APPNAME + '.pot').st_size
            except:
                size_old = 0
            subprocess.call (['intltool-update', '-p', '-g', APPNAME])
            size_new = os.stat (APPNAME + '.pot').st_size
            if size_new <> size_old:
                Logs.info("Updated po template.")
                try:
                    command = 'intltool-update -r -g %s' % APPNAME
                    self.exec_command (command)
                    Logs.info("Updated translations.")
                except:
                    Logs.error("Failed to update translations.")
        except:
            traceback.print_exc(file=open("errlog.txt","a"))
            Logs.error("Failed to generate po template.")
            Logs.errors("Make sure intltool is installed.")
        os.chdir ('..')

=== debian/changelog ===
diodon (1.0.1-0ubuntu1) raring; urgency=low

  * Initial release (LP: #808464)

 -- Oliver Sauder <os@esite.ch>  Fri, 04 Jan 2013 23:54:44 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/rules/buildvars.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/waf.mk

DEB_WAF_CONFIGURE_OPTIONS_ALL = --sysconfdir /etc --enable-unitylens-plugin --enable-zeitgeist-plugin --libdir /usr/lib/$(DEB_HOST_MULTIARCH)

# remove pyc files created by waf while building
clean::
	find -name '*.pyc' -delete

## diodon 1.0.2

=== wscript ===
--- 
+++ 
@@ -7,7 +7,7 @@
 from waflib.Tools import waf_unit_test
 
 NAME = 'Diodon'
-VERSION = '1.0.1'
+VERSION = '1.0.2'
 APPNAME = 'diodon'
 WEBSITE = 'https://launchpad.net/diodon'
 COPYRIGHT = 'Copyright \xc2\xa9 2010 Diodon Team'

=== debian/changelog ===
diodon (1.0.2-0ubuntu2) saucy; urgency=low

  * Deactivate unitylens-plugin (LP: #1189154)
  * debian/patches/01_port-to-zeitgeist-2.0.patch
    - Port to zeitgeist-2.0 (LP: #1197569)
  * Using valac dependency instead of valac-0.16

 -- Oliver Sauder <os@esite.ch>  Sun, 14 Jul 2013 23:58:19 +0300

diodon (1.0.2-0ubuntu1) raring; urgency=low

  * New upstream release.
  * run dh_icons for ubuntu themes for mono icons (LP: #1102708)

 -- Oliver Sauder <os@esite.ch>  Tue, 19 Feb 2013 22:41:39 +0200

=== debian/control ===
Source: diodon
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Oliver Sauder <os@esite.ch>
Build-Depends: cdbs (>= 0.4.90),
               debhelper (>= 9),
               gobject-introspection,
               intltool,
               libappindicator3-dev (>= 0.3.0),
               libdee-dev (>= 0.5.18),
               libgee-dev (>= 0.5.0),
               libglib2.0-dev (>=2.32),
               libgtk-3-dev (>=3.0.8),
               libpeas-dev (>=1.1.1),
               libunique-3.0-dev (>=3.0.0),
               libx11-dev (>= 1.3.2),
               libxml2-dev (>= 2.7.6),
               libxtst-dev (>= 1.2.0),
               libzeitgeist-2.0-dev (>= 0.9.14),
               python,
               valac (>=0.16.0)
Standards-Version: 3.9.4
Homepage: https://launchpad.net/diodon

Package: diodon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: diodon-plugins (= ${binary:Version})
Description: GTK+ Clipboard manager
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and an option to set the clipboard size.

Package: libdiodon0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GTK+ Clipboard manager (main library)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and an option to set the clipboard size.
 .
 This package contains the main library used by the Diodon. It is used both by
 the clipboard manager itself and by the plugins.
 .
 This library is only useful within Diodon. You should not have to
 manually install this package.

Package: gir1.2-diodon-1.0
Architecture: any
Depends: gir1.2-gee-1.0 (>= 0.5.0),
         gir1.2-glib-2.0,
         ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GTK+ Clipboard manager (GObject introspection data)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and an option to set the clipboard size.
 .
 This package contains introspection data for Diodon.
 .
 It can be used by packages using the GIRepository format to generate
 dynamic bindings.

Package: diodon-dev
Architecture: any
Section: devel
Depends: gir1.2-diodon-1.0 (= ${binary:Version}),
         libdiodon0 (= ${binary:Version}),
         libpeas-dev (>=1.1.1),
         ${misc:Depends}
Description: GTK+ Clipboard manager (development files)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and an option to set the clipboard size.
 .
 Diodon is also extensible through its plugin system.
 .
 This package is required to build plugins for Diodon.

Package: diodon-plugins
Architecture: any
Depends: diodon (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: GTK+ Clipboard manager (additional plugins)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and an option to set the clipboard size.
 .
 Diodon is also extensible through its plugin system.
 .
 This package contains following additional plugins:
 Zeitgeist Data-Source

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/rules/buildvars.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/waf.mk

DEB_WAF_CONFIGURE_OPTIONS_ALL = --sysconfdir /etc --enable-zeitgeist-plugin --libdir /usr/lib/$(DEB_HOST_MULTIARCH)

# remove pyc files created by waf while building
clean::
	find -name '*.pyc' -delete

# debhelper.mk targets, so silently ignored if debhelper.mk not included
$(patsubst %,binary-install/%,$(DEB_PACKAGES)) :: binary-install/%:
	$(if $(wildcard /usr/bin/dh_icons),dh_icons -p$(cdbs_curpkg) $(DEB_DH_ICONS_ARGS))

=== debian/watch ===
version=3
http://launchpad.net/diodon/+download .*/diodon-([0-9.]+)\.tar\.gz

## diodon 1.0.3

=== wscript ===
--- 
+++ 
@@ -7,7 +7,7 @@
 from waflib.Tools import waf_unit_test
 
 NAME = 'Diodon'
-VERSION = '1.0.2'
+VERSION = '1.0.3'
 APPNAME = 'diodon'
 WEBSITE = 'https://launchpad.net/diodon'
 COPYRIGHT = 'Copyright \xc2\xa9 2010 Diodon Team'

=== debian/changelog ===
diodon (1.0.3-1) unstable; urgency=low

  * New upstream release.
  * Added missing libgee-dev binding dependency
  * Using valac dependency instead of valac-0.16

 -- Oliver Sauder <os@esite.ch>  Sat, 13 Jul 2013 17:45:52 +0300

diodon (1.0.1-1) experimental; urgency=low

  * Initial release (Closes: #698282)

 -- Oliver Sauder <os@esite.ch>  Wed, 16 Jan 2013 10:59:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: diodon
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Oliver Sauder <os@esite.ch>
+Maintainer: Oliver Sauder <os@esite.ch>
 Build-Depends: cdbs (>= 0.4.90),
                debhelper (>= 9),
                gobject-introspection,
                intltool,
                libappindicator3-dev (>= 0.3.0),
-               libdee-dev (>= 0.5.18),
                libgee-dev (>= 0.5.0),
                libglib2.0-dev (>=2.32),
                libgtk-3-dev (>=3.0.8),
@@ -17,11 +15,13 @@
                libx11-dev (>= 1.3.2),
                libxml2-dev (>= 2.7.6),
                libxtst-dev (>= 1.2.0),
-               libzeitgeist-2.0-dev (>= 0.9.14),
+               libzeitgeist-dev (>= 0.3.12),
                python,
                valac (>=0.16.0)
 Standards-Version: 3.9.4
 Homepage: https://launchpad.net/diodon
+Vcs-Bzr: lp:diodon
+Vcs-Browser: https://code.launchpad.net/~diodon-team/diodon/trunk
 
 Package: diodon
 Architecture: any
@@ -76,6 +76,7 @@
 Section: devel
 Depends: gir1.2-diodon-1.0 (= ${binary:Version}),
          libdiodon0 (= ${binary:Version}),
+         libgee-dev (>= 0.5.0),
          libpeas-dev (>=1.1.1),
          ${misc:Depends}
 Description: GTK+ Clipboard manager (development files)
@@ -102,4 +103,4 @@
  Diodon is also extensible through its plugin system.
  .
  This package contains following additional plugins:
- Zeitgeist Data-Source
+  * Unity Lens

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,3 @@
 # remove pyc files created by waf while building
 clean::
 	find -name '*.pyc' -delete
-
-# debhelper.mk targets, so silently ignored if debhelper.mk not included
-$(patsubst %,binary-install/%,$(DEB_PACKAGES)) :: binary-install/%:
-	$(if $(wildcard /usr/bin/dh_icons),dh_icons -p$(cdbs_curpkg) $(DEB_DH_ICONS_ARGS))

## diodon 1.2.0

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Oliver Sauder, 2010

from subprocess import Popen, PIPE
import os, traceback, waflib, tempfile, time, signal, random, dbus, subprocess
import Options, Logs
from waflib.Build import BuildContext
from waflib.Tools import waf_unit_test

NAME = 'Diodon'
VERSION = '1.2.0'
APPNAME = 'diodon'
WEBSITE = 'https://launchpad.net/diodon'
COPYRIGHT = 'Copyright \xc2\xa9 2010-2014 Diodon Team'
BUSNAME = 'net.launchpad.Diodon'
BUSOBJECTPATH = '/net/launchpad/diodon'

VERSION_MAJOR_MINOR = '.'.join (VERSION.split ('.')[0:2])
VERSION_MAJOR = '.'.join (VERSION.split ('.')[0:1])
top = '.'
out = '_build_'

class CustomBuildContext(BuildContext):
    zeitgeist_process = None
    dbus = None

def options(opt):
    opt.tool_options('compiler_c')
    opt.tool_options('waf_unit_test')
    opt.tool_options('vala')
    opt.tool_options('gnu_dirs')
    opt.tool_options('intltool')
    opt.tool_options('glib2')
    opt.add_option('--update-po',                action='store_true', default=False, dest='update_po', help='Update localization files')
    opt.add_option('--debug',                    action='store_true', default=False, dest='debug',     help='Debug mode')
    opt.add_option('--disable-indicator-plugin', action='store_true', default=False, dest='disable_indicator', help='Disable build of indicator plugin')
    opt.add_option('--enable-unityscope',        action='store_true', default=False, dest='enable_unityscope', help='Enable build of unity scope')
    opt.add_option('--build-doc',                action='store_true', default=False, dest='doc', help='Build the api documentation')
    opt.add_option('--skiptests',                action='store_true', default=False, dest='skiptests', help='Skip unit tests')

def configure(conf):
    conf.load('compiler_c intltool gnu_dirs glib2 waf_unit_test')
    if Options.options.doc:
    	conf.load('valadoc')
    
    conf.load('vala', funs='')
    conf.check_vala(min_version=(0,20,0))
    
    conf.check_cfg(package='gdk-3.0',           uselib_store='GDK',          atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gdk-x11-3.0',       uselib_store='GDKX',         atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gee-0.8',           uselib_store='GEE',          atleast_version='0.10.5',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='libpeas-1.0',       uselib_store='PEAS',         atleast_version='1.1.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='libpeas-gtk-1.0',   uselib_store='PEASGTK',      atleast_version='1.1.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gio-2.0',           uselib_store='GIO',          atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gio-unix-2.0',      uselib_store='GIOUNIX',      atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='glib-2.0',          uselib_store='GLIB',         atleast_version='2.32.0', mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='gtk+-3.0',          uselib_store='GTK',          atleast_version='3.0.8',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='x11',               uselib_store='X11',          atleast_version='1.3.2',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='xtst',              uselib_store='XTST',         atleast_version='1.2.0',  mandatory=1, args='--cflags --libs')
    conf.check_cfg(package='zeitgeist-2.0',     uselib_store='ZEITGEIST',    atleast_version='0.9.14', mandatory=1, args='--cflags --libs')    
    
    # FIXME: waf throws up when assigning an empty string
    # we need a better way of configuring plugins which are enabled
    # by default anyway
    ACTIVE_PLUGINS = ' '
    # check if indicator plugin should be built
    conf.env['INDICATOR'] = not(Options.options.disable_indicator)
    if not(Options.options.disable_indicator):
        conf.check_cfg(package='appindicator3-0.1', uselib_store='APPINDICATOR', atleast_version='0.3.0',  mandatory=1, args='--cflags --libs')
        ACTIVE_PLUGINS = "'indicator'"
        
    # check if unity scope plugin should be built
    conf.env['UNITYSCOPE'] = Options.options.enable_unityscope
    if Options.options.enable_unityscope:
        conf.check_cfg(package='unity', uselib_store='UNITY', atleast_version='7.1.0',mandatory=1, args='--cflags --libs')

    # FIXME: conf.env and conf.define should not both be needed?
    conf.define('PACKAGE_NAME', APPNAME)
    conf.env['PACKAGE_NAME'] = APPNAME
    conf.define('ACTIVE_PLUGINS', ACTIVE_PLUGINS)
    conf.env['ACTIVE_PLUGINS'] = ACTIVE_PLUGINS
    conf.define('GETTEXT_PACKAGE', APPNAME)
    conf.env['GETTEXT_PACKAGE'] = APPNAME
    conf.define('VERSION', VERSION)
    conf.env['VERSION'] = VERSION
    conf.define('COPYRIGHT', COPYRIGHT)
    conf.define('WEBSITE', WEBSITE)
    conf.define('APPNAME', NAME)
    conf.define('BUSNAME', BUSNAME)
    conf.env['BUSNAME'] = BUSNAME
    conf.define('BUSOBJECTPATH', BUSOBJECTPATH)
    conf.env['BUSOBJECTPATH'] = BUSOBJECTPATH
    conf.define('SHAREDIR', os.path.join(conf.env['DATADIR'], APPNAME))
    conf.define('LIBDIR_DIODON', os.path.join(conf.env['LIBDIR'], APPNAME))
    conf.env['LIBDIR_DIODON'] = os.path.join(conf.env['LIBDIR'], APPNAME)
    conf.define('PLUGINS_DIR', os.path.join(conf.env['LIBDIR'], APPNAME, 'plugins'))
    conf.env['PLUGINS_DIR'] = os.path.join(conf.env['LIBDIR'], APPNAME, 'plugins')
    conf.define('PLUGINS_DATA_DIR', os.path.join(conf.env['DATADIR'], APPNAME, 'plugins'))
    conf.define('TEST_DATA_DIR', conf.path.abspath() + '/tests/data/')
      
    # set 'default' variant
    conf.define ('DEBUG', 0)
    conf.env['CFLAGS'] = ['-O2', '-w']
    conf.env['VALAFLAGS'] = ['--disable-assert']
    
    # set some debug relevant config values
    if Options.options.debug:
        conf.define ('DEBUG', 1)
        conf.env['CFLAGS'] = ['-O0', '-g3', '-w']
        conf.env['VALAFLAGS'] = ['-g', '-v', '--enable-checking']

    conf.write_config_header ('config.h', remove=False)

def build(ctx):
    ctx.add_subdirs('po data libdiodon plugins diodon')
    
    if ctx.env['UNITYSCOPE']:
        ctx.add_subdirs('unity-scope-diodon')
        
    if not Options.options.skiptests:
        ctx.add_subdirs('tests')
        if ctx.cmd == 'build':
            ctx.add_pre_fun(setup_tests)
            ctx.add_post_fun(teardown_tests)
        
    if ctx.env['VALADOC']:
    	ctx.add_subdirs('doc')
    ctx.add_post_fun(post)
    
    # to execute all tests:
	# $ waf --alltests
	# to set this behaviour permanenly:    
    ctx.options.all_tests = True

def setup_tests(ctx):
    ctx.dbus = DBusPrivateMessageBus()
    error = ctx.dbus.run()

    Logs.info("Testsuite is running using a private dbus bus")
    config = ctx.dbus.dbus_config.copy()
    config.update({"DISPLAY": ctx.dbus.DISPLAY, "pid.Xvfb": ctx.dbus.display.pid})
        
    ctx.zeitgeist_process = start_zeitgeist_daemon()
    
# TODO: is this really the best spot to start the zeitgeist daemon?
def start_zeitgeist_daemon():
    """
    start zeitgeist daemon writing to temporary data path
    """
    zg_env = os.environ.copy()
    datapath = tempfile.mkdtemp(prefix="zeitgeist.datapath.")
    zg_env.update({
        "ZEITGEIST_DATABASE_PATH": ":memory:",
        "ZEITGEIST_DATA_PATH": datapath,
        "XDG_CACHE_HOME": os.path.join(datapath, "cache"),
    })
    args = { 'env': zg_env }
    args['stderr'] = PIPE
    args['stdout'] = PIPE
    zeitgeist_process = Popen(('/usr/bin/zeitgeist-daemon', '--replace', '--no-datahub'), **args)
    
    # give the process some time to wake up
    time.sleep(1)
    
    # raise runtime error if process failed to start
    error = zeitgeist_process.poll()
    if error:
        error = "zeitgeist-daemon exits with error %i." %(error)
        raise RuntimeError(error)
    
    return zeitgeist_process
    
def teardown_tests(ctx):
    stop_zeitgeist_daemon(ctx.zeitgeist_process)
    ctx.dbus.quit(ignore_errors=True)
    
    # write test summary
    waf_unit_test.summary(ctx)

    # Ensure that all tests have passed, if not log errors
    lst = getattr(ctx, 'utest_results', [])
    if lst:
        tfail = len([x for x in lst if x[1]])
        if tfail:
            for (filename, returncode, stdout, stderr) in lst:
                Logs.warn(stdout)
                Logs.warn(stderr)
                
            ctx.fatal("Some test failed.")
   
def stop_zeitgeist_daemon(zeitgeist_process):
    """
    Kill started test zeitgeist daemon
    """
    os.kill(zeitgeist_process.pid, signal.SIGKILL)
    zeitgeist_process.wait()

def post(ctx):
    if ctx.cmd == 'install':
        ctx.exec_command('/sbin/ldconfig')

def dist(ctx):
    # set the compression type to gzip (default is bz2)
    ctx.algo = "tar.gz"
  
def shutdown(self):
    if Options.options.update_po:
        os.chdir('./po')
        try:
            try:
                size_old = os.stat (APPNAME + '.pot').st_size
            except:
                size_old = 0
            subprocess.call (['intltool-update', '-p', '-g', APPNAME])
            size_new = os.stat (APPNAME + '.pot').st_size
            if size_new <> size_old:
                Logs.info("Updated po template.")
                try:
                    command = 'intltool-update -r -g %s' % APPNAME
                    self.exec_command (command)
                    Logs.info("Updated translations.")
                except:
                    Logs.error("Failed to update translations.")
        except:
            traceback.print_exc(file=open("errlog.txt","a"))
            Logs.error("Failed to generate po template.")
            Logs.errors("Make sure intltool is installed.")
        os.chdir ('..')

# TODO class needs to be moved elsewhere, waf task might be considered
class DBusPrivateMessageBus(object):
	# Choose a random number so it's possible to have more than
	# one test running at once.
	DISPLAY = ":%d" % random.randint(20, 100)

	def _run(self):
		os.environ.update({"DISPLAY": self.DISPLAY})
		devnull = file("/dev/null", "w")
		self.display = Popen(
			["Xvfb", self.DISPLAY, "-screen", "0", "1024x768x8"],
			stderr=devnull, stdout=devnull
		)
		# give the display some time to wake up
		time.sleep(1)
		err = self.display.poll()
		if err:
			raise RuntimeError("Could not start Xvfb on display %s, got err=%i" %(self.DISPLAY, err))
		dbus = Popen(["dbus-launch"], stdout=PIPE)
		time.sleep(1)
		self.dbus_config = dict(l.split("=", 1) for l in dbus.communicate()[0].split("\n") if l)
		os.environ.update(self.dbus_config)
		
	def run(self, ignore_errors=False):
		try:
			return self._run()
		except Exception, e:
			if ignore_errors:
				return e
			raise

	def _quit(self):
		os.kill(self.display.pid, signal.SIGKILL)
		self.display.wait()
		pid = int(self.dbus_config["DBUS_SESSION_BUS_PID"])
		os.kill(pid, signal.SIGKILL)
		try:
			os.waitpid(pid, 0)
		except OSError:
			pass
			
	def quit(self, ignore_errors=False):
		try:
			return self._quit()
		except Exception, e:
			if ignore_errors:
				return e
			raise

=== debian/changelog ===
diodon (1.2.0-0ubuntu1) utopic; urgency=medium

  * New upstream release.
  * Removed obsolete libunique dependency (LP: #1310360)
  * Updated to libgee-0.8 dependency (LP: #1348994)
  * diodon needs specific version of libdiodon0 (LP: #1347181)
  * Added deps dbus-x11, at-spi2-core, python-dbus,
    zeitgeist-core and xvfb to run tests
  * out-of-date-standards-version, updated to 3.9.5
  * Replaced diodon-plugins with unity-scope-diodon package
  * Fixing wrong-section-according-to-package-name gir1.2-diodon-1.0
  * Override gsettings to show clipboard.scope icon in dash
  * Dropped obsolete patch 01_port-to-zeitgeist-2.0.patch

 -- Oliver Sauder <os@esite.ch>  Mon, 04 Aug 2014 14:37:37 +0300

=== debian/control ===
Source: diodon
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Oliver Sauder <os@esite.ch>
Build-Depends: at-spi2-core,
               cdbs (>= 0.4.90),
               dbus-x11,
               debhelper (>= 9),
               gobject-introspection,
               intltool,
               libappindicator3-dev (>= 0.3.0),
               libgee-0.8-dev (>= 0.10.5),
               libglib2.0-dev (>=2.32),
               libgtk-3-dev (>=3.0.8),
               libpeas-dev (>=1.1.1),
               libunity-dev (>= 5.8.0),
               libx11-dev (>= 1.3.2),
               libxtst-dev (>= 1.2.0),
               libzeitgeist-2.0-dev (>= 0.9.14),
               python,
               python-dbus,
               valac (>=0.20.0),
               xvfb,
               zeitgeist-core
Standards-Version: 3.9.5
Homepage: https://launchpad.net/diodon

Package: diodon
Architecture: any
Depends: libdiodon0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: unity-scope-diodon (= ${binary:Version})
Description: GTK+ Clipboard manager
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and a zeitgeist integration for an infinite
 clipboard history.

Package: libdiodon0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GTK+ Clipboard manager (main library)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and a zeitgeist integration for an infinite
 clipboard history.
 .
 This package contains the main library used by the Diodon. It is used both by
 the clipboard manager itself and by the plugins.
 .
 This library is only useful within Diodon. You should not have to
 manually install this package.

Package: gir1.2-diodon-1.0
Architecture: any
Section: introspection
Depends: gir1.2-gee-0.8 (>= 0.10.5),
         gir1.2-glib-2.0,
         ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GTK+ Clipboard manager (GObject introspection data)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and a zeitgeist integration for an infinite
 clipboard history.
 .
 This package contains introspection data for Diodon.
 .
 It can be used by packages using the GIRepository format to generate
 dynamic bindings.

Package: diodon-dev
Architecture: any
Section: devel
Depends: gir1.2-diodon-1.0 (= ${binary:Version}),
         libdiodon0 (= ${binary:Version}),
         libgee-0.8-dev (>= 0.10.5),
         libpeas-dev (>=1.1.1),
         ${misc:Depends}
Description: GTK+ Clipboard manager (development files)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and a zeitgeist integration for an infinite
 clipboard history.
 .
 Diodon is also extensible through its plugin system.
 .
 This package is required to build plugins for Diodon.

Package: unity-scope-diodon
Architecture: any
Depends: diodon (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: GTK+ Clipboard manager (Unity Scope)
 Diodon is a lightweight clipboard manager for Linux written in Vala which
 "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".
 .
 Diodon features include Ubuntu indicator, clipboard sync (primary selection
 and Ctrl+C / Ctrl+V clipboard) and a zeitgeist integration for an infinite
 clipboard history.
 .
 This package contains an Unity Scope to access the clipboard history.

## diodon 1.3.0

=== wscript ===
--- 
+++ 
@@ -9,7 +9,7 @@
 from waflib.Tools import waf_unit_test
 
 NAME = 'Diodon'
-VERSION = '1.2.0'
+VERSION = '1.3.0'
 APPNAME = 'diodon'
 WEBSITE = 'https://launchpad.net/diodon'
 COPYRIGHT = 'Copyright \xc2\xa9 2010-2014 Diodon Team'

=== debian/changelog ===
diodon (1.3.0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/{control, unity*, rules}:
      + Add Unity Scope plugin.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 27 Dec 2015 16:06:04 +0100

diodon (1.3.0-1) unstable; urgency=medium

  * New upstream release.
  * Removed obsolete libunique and libxml dependency
  * Updated to libgee-0.8 dependency (Closes: #753859)
  * Allows autostart on all DEs except KDE (Closes: #777670)
  * diodon needs specific version of libdiodon0
  * Added deps dbus-x11, at-spi2-core, python-dbus,
    zeitgeist-core and xvfb to run tests
  * out-of-date-standards-version, updated to 3.9.5
  * Fixed debian-watch-may-check-gpg-signature
  * Removed obsolete package diodon-plugins
  * Fixing wrong-section-according-to-package-name gir1.2-diodon-1.0
  * make sure that dh_icons gets called
  * Make gir1.2- package Multi-Arch: same

 -- Oliver Sauder <os@esite.ch>  Sat, 21 Feb 2015 21:11:07 +0300

=== debian/control ===
--- 
+++ 
@@ -23,12 +23,15 @@
                valac (>=0.20.0),
                xvfb,
                zeitgeist-core
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: https://launchpad.net/diodon
 
 Package: diodon
 Architecture: any
-Depends: libdiodon0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libdiodon0 (= ${binary:Version}),
+         zeitgeist-core (>= 0.9.14),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: unity-scope-diodon (= ${binary:Version})
 Description: GTK+ Clipboard manager
  Diodon is a lightweight clipboard manager for Linux written in Vala which
@@ -59,6 +62,7 @@
 
 Package: gir1.2-diodon-1.0
 Architecture: any
+Multi-Arch: same
 Section: introspection
 Depends: gir1.2-gee-0.8 (>= 0.10.5),
          gir1.2-glib-2.0,
@@ -100,7 +104,9 @@
 
 Package: unity-scope-diodon
 Architecture: any
-Depends: diodon (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: diodon (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: GTK+ Clipboard manager (Unity Scope)
  Diodon is a lightweight clipboard manager for Linux written in Vala which
  "aims to be the best integrated clipboard manager for the Gnome/Unity desktop".

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/rules/buildvars.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/waf.mk

DEB_WAF_CONFIGURE_OPTIONS_ALL = --sysconfdir /etc --enable-unityscope --libdir /usr/lib/$(DEB_HOST_MULTIARCH)

# remove pyc files created by waf while building
clean::
	find -name '*.pyc' -delete

# debhelper.mk targets, so silently ignored if debhelper.mk not included
$(patsubst %,binary-install/%,$(DEB_PACKAGES)) :: binary-install/%:
	$(if $(wildcard /usr/bin/dh_icons),dh_icons -p$(cdbs_curpkg) $(DEB_DH_ICONS_ARGS))

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ http://launchpad.net/diodon/+download .*/diodon-([0-9.]+)\.tar\.gz
